//
//  BCIDACustomLog.h
//  OneAccess2C_realAuth
//
//  Created by 栗子小西 on 2021/7/23.
//  Copyright © 2021 栗子小西. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

//  Custom_NSLog.h

//  VoiceChat

//  Created by tl on 16/4/7.

//  Copyright © 2016年 A. All rights reserved.

//  自定义Log类，外部控制Log开关#import

/**

*  自定义Log，可配置开关（用于替换NSLog）

*/
//#ifdef DEBUG
//#define BCIDACustomLog(fmt, ...) CustomLog((@"%s [Line %d] " fmt), __PRETTY_FUNCTION__, __LINE__, ##__VA_ARGS__);
//#define BCIDAErrorLog( format, ... )  NSLog( @"[ErrorLog]<%p %@:(%d)> %@", self, [[NSString stringWithUTF8String:__FILE__] lastPathComponent], __LINE__, [NSString stringWithFormat:(format), ##__VA_ARGS__] )
//
//#else
//#define BCIDACustomLog(fmt, ...) CustomLog((@"%s [Line %d] " fmt), __PRETTY_FUNCTION__, __LINE__, ##__VA_ARGS__); nil
//#define BCIDAErrorLog( format, ... )  NSLog( @"[ErrorLog]<%p %@:(%d)> %@", self, [[NSString stringWithUTF8String:__FILE__] lastPathComponent], __LINE__, [NSString stringWithFormat:(format), ##__VA_ARGS__] )
//
//#endif

#ifdef DEBUG
#define BCIDACustomLog(format, ... )  CustomLog(__FUNCTION__,__LINE__,format,##__VA_ARGS__);
#define BCIDAErrorLog( format, ... )  NSLog( @"[ErrorLog]<%p %@:(%d)> %@", self, [[NSString stringWithUTF8String:__FILE__] lastPathComponent], __LINE__, [NSString stringWithFormat:(format), ##__VA_ARGS__] )

#else
#define BCIDACustomLog(format, ... )  CustomLog(__FUNCTION__,__LINE__,format,##__VA_ARGS__); 
#define BCIDAErrorLog( format, ... )  NSLog( @"[ErrorLog]<%p %@:(%d)> %@", self, [[NSString stringWithUTF8String:__FILE__] lastPathComponent], __LINE__, [NSString stringWithFormat:(format), ##__VA_ARGS__] )

#endif
/**

*  自定义Log

*  @warning 外部可直接调用 NSLog_Custom

*  @param  func        方法名

*  @param  lineNumber  行号

*  @param  format      Log内容

*  @param  ...          个数可变的Log参数

*/

void CustomLog(const char *func, int lineNumber, NSString *format, ...);


@interface BCIDACustomLog : NSObject
/**

*  Log 输出开关 (默认开启)

*  @param flag 是否开启 YES:显示；NO:不显示

*/

+ (void)setLogEnable:(BOOL)flag;

/**

*  是否开启了 Log 输出

*  @return Log 开关状态

*/

+ (BOOL)logEnable;


@end

NS_ASSUME_NONNULL_END
