//
//  DDDResponseModel.h
//  DDDdiandingdang
//
//  Created by AB on 2019/4/10.
//  Copyright © 2019 chenganyunchuang. All rights reserved.
//

#import "BCIDABaseDomain1.h"
#import "BCIDAPagination.h"

/**
 *  返回状态码
 */
typedef NS_ENUM(NSInteger, ResponseStatus){
    ResponseStatusSuccess = 0,
    ResponseStatusError = 404
};


//
//typedef NS_ENUM(NSInteger, BCResultsStatus){
//    SUCCESS = 0,
//    LOCKED_OUT = 1,
//    PASSWORD_EXPIRED=2,
//    PASSWORD_WARN=3,
//    SOCIAL_BIND=4,
//    USER_REGISTER=5,
//    MFA_AUTH=6
//};

static const NSString* bcresultSuccess=@"SUCCESS";
static const NSString* bcresultLockOut=@"LOCKED_OUT";
static const NSString* bcresultPasswordExpire=@"PASSWORD_EXPIRED";
static const NSString* bcresultPasswordWarn=@"PASSWORD_WARN";
static const NSString* bcresultSocialBind=@"SOCIAL_BIND";
static const NSString* bcresultUserRegister=@"USER_REGISTER";
static const NSString* bcresultMfaAuth=@"MFA_AUTH";
static const NSString* bcresultDenied=@"ACCESS_DENIED";

static const NSInteger BCIDAHttpSuccess=200;
static const NSInteger BCIDAHttpFail=400;

typedef void (^BCIDAResultsSuccessBlock)(NSString* status,NSString* sessionToken,NSNumber* expire,id extraData);
typedef void (^BCIDAResultsFailBlock)(NSString* error_code,NSString* error_msg);
typedef void (^BCIDAResultsOtherDataBlock)(NSString* status,NSString* state_token,id data,id extraData);




/**
 *  请求成功回调
 *
 *  @param data 返回数据 集合或者字典
 */
typedef void (^BCIDARequestSuccessBlock)(id data,BCIDAPagination *pagination);


/**
 *  请求失败回调
 *
 *  @param msg 失败提示
 */
typedef void (^BCIDARequestErrorWithDataBlock)(NSString *err_code,id data);
/**
 *  网络超时或者sid失效
 *
 *  @param error 错误
 */
typedef void (^BCIDARequestFailureBlock)(NSError *error);
/**
 *  返回数据
 */




@interface BCIDAResponseModel : BCIDABaseDomain1



///**
// *  检查返回值
// *
// *  @return 成功YES 失败NO
// */
//+(BOOL)checkStatus:(NSMutableDictionary*)responseDic;
//+(NSMutableDictionary*)encodeResponse:(id)responseObject;
/**
 *  通过attributes判断是否请求成功
 *
 *  @param responseBody         AFNhttp返回的 responseBody
 *  @param requestSuccessBlock 请求成功
 *  @param requestErrorBlock   请求错误
 *
 *  @return 返回请求是否成功
 */

//当responsebody 需要encode成dictionary的时候
//+ (BOOL)initWithResponseBody:(id)responseBody andRequestSuccessBlock:(BCIDARequestSuccessBlock)requestSuccessBlock
//        andRequestErrorBlock:(BCIDARequestErrorWithDataBlock)requestErrorBlock;
//
////当responsebody 直接是dictionary时
//+ (BOOL)initWithResponseBodyDictionary:(NSDictionary*)responseBody andRequestSuccessBlock:(BCIDARequestSuccessBlock)requestSuccessBlock
//                  andRequestErrorBlock:(BCIDARequestErrorWithDataBlock)requestErrorBlock;
//+(void)initWithResponseBody:(NSDictionary*)responseDic WithResultSuccessBlock:(BCIDAResultsSuccessBlock)resultSucessBlock andWithResultOtherDataBlock:(BCIDAResultsOtherDataBlock)resultOtherBlock andWithResultFailBlock:(BCIDAResultsFailBlock)resultFailBlock;


+(void)parseSuccessResultWithSTATUSResponseBodyDictionary:(NSDictionary*)responseBody WithResultSuccessBlock:(BCIDAResultsSuccessBlock)resultSucessBlock andWithResultOtherDataBlock:(BCIDAResultsOtherDataBlock)resultOtherBlock andWithResultFailBlock:(BCIDAResultsFailBlock)resultFailBlock;



@end
