//
//  NSArray+BCIDAMASShorthandAdditions.h
//  Masonry
//
//  Created by Jonas Budelmann on 22/07/13.
//  Copyright (c) 2013 Jonas Budelmann. All rights reserved.
//

#import "NSArray+BCIDAMASAdditions.h"

#ifdef MAS_SHORTHAND

/**
 *	Shorthand array additions without the 'mas_' prefixes,
 *  only enabled if MAS_SHORTHAND is defined
 */
@interface NSArray (BCIDAMASShorthandAdditions)

- (NSArray *)makeConstraints:(void(^)(BCIDAMASConstraintMaker *make))block;
- (NSArray *)updateConstraints:(void(^)(BCIDAMASConstraintMaker *make))block;
- (NSArray *)remakeConstraints:(void(^)(BCIDAMASConstraintMaker *make))block;

@end

@implementation NSArray (BCIDAMASShorthandAdditions)

- (NSArray *)makeConstraints:(void(^)(BCIDAMASConstraintMaker *))block {
    return [self mas_makeConstraints:block];
}

- (NSArray *)updateConstraints:(void(^)(BCIDAMASConstraintMaker *))block {
    return [self mas_updateConstraints:block];
}

- (NSArray *)remakeConstraints:(void(^)(BCIDAMASConstraintMaker *))block {
    return [self mas_remakeConstraints:block];
}

@end

#endif
